Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright © 2006 BEA Systems, Inc. All Rights Reserved
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.content.expression
Class Search

    java.lang.Object
      com.bea.content.expression.Search

All Implemented Interfaces
  Serializable, Cloneable

    public class Search

extends Object
implements Cloneable, Serializable

This represents parameters for searching for Nodes.

There are reserved system properties that may be part of a search. They are:

- cm_uid -> Node.id.uid
- cm_createdDate -> Node.createDate
- cm_createdBy -> Node.createdBy
- cm_modifiedDate -> Node.modifiedBy
- cm_nodeName -> Node.name
- cm_path -> Node.path
- cm_isHierarchy -> Node.type == Node.HIERARCHY
- cm_isContent -> Node.type == Node.CONTENT
- cm_objectClass -> Node.objectClass.name
- cm_objectClassInstance -> Instance of an object class
- cm_contentType -> BinaryValue.contentType
- cm_binarySize -> BinaryValue.size (For Node Properties)
- cm_binaryName -> BinaryValue.name (For Node Properties)

Node link properties are not currently supported in a search expression.

See Also
  Serialized Form

Field Summary
`protected Map` | `contextParams` The context params.
`protected Expression` | `expression` The search expression.
`protected IFullTextSearch` | `fullText` The full text search expression.
`protected int` | `maxReturn` The maximum number of objects to return.
`protected List` | `searchPaths` The paths under which to search.
`protected SortCriteria[]` | `sortCriteria` The sorting criteria
`protected boolean` | `useCache` indicates whether or not the search should use the cache or not
`protected boolean` | `useFullTextSearch` Whether a full text search is to be performed instead of a database search.

Constructor Summary
`Search()` Empty constructor.
`Search(Expression expr)` Constructor.
`Search(int maxReturn, Expression expr)` Constructor.
`Search(int maxReturn, SortCriteria[] sortCriteria, Expression expr)` Constructor.
`Search(int maxReturn, SortCriteria[] sortCriteria, String expr)` Constructor.
`Search(int maxReturn, String expr)` Constructor.
`Search(int maxReturn, String sort, Expression expr)` Constructor.
`Search(int maxReturn, String sort, String expr)` Constructor.
`Search(String expr)` Constructor.
`Search(String searchPath, int maxReturn, SortCriteria[] sortCriteria, Expression expr)` Constructor.
`Search(String searchPath, int maxReturn, SortCriteria[] sortCriteria, IFullTextSearch expr, boolean performFullTextSearch)` Constructor.
`Search(String searchPath, int maxReturn, SortCriteria[] sortCriteria, String expr)` Constructor.
`Search(String searchPath, int maxReturn, String sort, Expression expr)` Constructor.
`Search(String searchPath, int maxReturn, String sort, String expr)` Constructor.

Method Summary
`void` | `addSearchPath(String path)` Add a search path.
`void` | `clearSearchPaths()` Clear the search paths.
`Object` | `clone()` Make a deep copy of this object
`boolean` | `equals(Object o)` Determine if another object is equals to this.
`Object` | `getContextParam(Object key)` Get the value of a context param.
`Map` | `getContextParams()` Get an unmodifiable copy of the context params.
`Expression` | `getExpression()` Get the search expression.
`IFullTextSearch` | `getFullTextExpression()` Get the search expression corresponding to a full text search.
`int` | `getMaxReturn()` Get the maximum number of objects to return.
`int` | `getNumSearchPaths()` Get the number of search paths.
`String[]` | `getSearchPaths()` Get the search paths.
`Iterator` | `getSearchPathsIterator()` Get an iterator over the search paths.
`SortCriteria[]` | `getSortCriteria()` Get the sort criteria.
`int` | `hashCode()` Override hashcode to use our parts.
`boolean` | `isFullTextSearch()` Check if this is a Full Text Search instead of the Database Search
`boolean` | `isUseCache()` Indicates whether or not the search, when executed will try to use the global search cache or not.
`void` | `removeSearchPath(String path)` Remove a search path.
`Object` | `setContextParam(Object key, Object value)` Set the value of a context param.
`void` | `setContextParams(Map input)` Set the context params based upon the objects in the input map.
`void` | `setExpression(Expression expression)` Set the search expression.
`void` | `setFullTextExpression(IFullTextSearch expression)` Set the search expression corresponding to a full text search.
`void` | `setFullTextSearch(boolean fullTextSearch)` Enable/Disable Full Text Search
`void` | `setMaxReturn(int maxReturn)` Set the maximum number of objects to return.
`void` | `setSearchPath(String searchPath)` Set the search path to contain just this one.
`void` | `setSearchPaths(String[] paths)` Set the search paths.
`void` | `setSortCriteria(SortCriteria[] sortCriteria)` Set the sort criteria.
`void` | `setSortCriteria(String sort)` Set the sort criteria.
`void` | `setUseCache(boolean useCache)` Indicates to the search API whether or not to use the search cache when executing the search expression.
`String` | `toString()` Get a String representation of this.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### searchPaths

    protected List searchPaths

  The paths under which to search.

  This should be empty to search under all paths (repositories in a federeated search.) This is an OR'ed list.

  In a federated search, this can begin with "/*" (e.g."/*/some/path") to denote a search path under each repository. In non-federated search, this should not be construed to contain any special characters.

### maxReturn

    protected int maxReturn

  The maximum number of objects to return.

  Less than 0 signifies returning all matches.

### sortCriteria

    protected SortCriteria[] sortCriteria

  The sorting criteria

### expression

    protected Expression expression

  The search expression.

### fullText

    protected IFullTextSearch fullText

  The full text search expression.

### contextParams

    protected Map contextParams

  The context params.

  Note from com.bea.p13n.content.expression.Search: Attribute: `contextParams`

  - Containment: By Value
  - Multiplicity: 1:1
  - This can other arbitrary parameters to pass through to the document manager. Only Serializable objects should go into this. These are not used to determine equality.

### useCache

    protected boolean useCache

  indicates whether or not the search should use the cache or not

### useFullTextSearch

    protected boolean useFullTextSearch

  Whether a full text search is to be performed instead of a database search.

Constructor Detail

### Search

    public Search(String searchPath,
                  int maxReturn,
                  SortCriteria[] sortCriteria,
                  IFullTextSearch expr,
                  boolean performFullTextSearch)

  Constructor.

### Search

    public Search(String searchPath,
                  int maxReturn,
                  SortCriteria[] sortCriteria,
                  Expression expr)

  Constructor.

### Search

    public Search(String searchPath,
                  int maxReturn,
                  SortCriteria[] sortCriteria,
                  String expr)
           throws IllegalArgumentException

  Constructor.

  Throws
    `IllegalArgumentException`

### Search

    public Search(String searchPath,
                  int maxReturn,
                  String sort,
                  Expression expr)
           throws IllegalArgumentException

  Constructor.

  Throws
    `IllegalArgumentException`

### Search

    public Search(String searchPath,
                  int maxReturn,
                  String sort,
                  String expr)
           throws IllegalArgumentException

  Constructor.

  Throws
    `IllegalArgumentException`

### Search

    public Search(int maxReturn,
                  SortCriteria[] sortCriteria,
                  Expression expr)

  Constructor.

### Search

    public Search(int maxReturn,
                  SortCriteria[] sortCriteria,
                  String expr)
           throws IllegalArgumentException

  Constructor.

  Throws
    `IllegalArgumentException`

### Search

    public Search(int maxReturn,
                  String sort,
                  Expression expr)
           throws IllegalArgumentException

  Constructor.

  Throws
    `IllegalArgumentException`

### Search

    public Search(int maxReturn,
                  String sort,
                  String expr)
           throws IllegalArgumentException

  Constructor.

  Throws
    `IllegalArgumentException`

### Search

    public Search(int maxReturn,
                  Expression expr)

  Constructor.

### Search

    public Search(int maxReturn,
                  String expr)
           throws IllegalArgumentException

  Constructor.

  Throws
    `IllegalArgumentException`

### Search

    public Search(Expression expr)

  Constructor.

### Search

    public Search(String expr)
           throws IllegalArgumentException

  Constructor.

  Throws
    `IllegalArgumentException`

### Search

    public Search()

  Empty constructor.

Method Detail

### isFullTextSearch

    public boolean isFullTextSearch()

  Check if this is a Full Text Search instead of the Database Search

  Returns
    true - to indicate that full text search is being used.

### setFullTextSearch

    public void setFullTextSearch(boolean fullTextSearch)

  Enable/Disable Full Text Search

  Parameters
    `fullTextSearch` - To enable, set to "true"; to disable full text search (and use database search instead), set to "false".

### getSearchPaths

    public String[] getSearchPaths()

  Get the search paths.

  See `searchPaths` for details about what this can be.

### getSearchPathsIterator

    public Iterator getSearchPathsIterator()

  Get an iterator over the search paths.

  See `searchPaths` for details about what this can be.

### getNumSearchPaths

    public int getNumSearchPaths()

  Get the number of search paths.

### setSearchPath

    public void setSearchPath(String searchPath)

  Set the search path to contain just this one.

  See `searchPaths` for details about what this can be.

### setSearchPaths

    public void setSearchPaths(String[] paths)

  Set the search paths.

### addSearchPath

    public void addSearchPath(String path)

  Add a search path.

  See `searchPaths` for details about what this can be.

### removeSearchPath

    public void removeSearchPath(String path)

  Remove a search path.

### clearSearchPaths

    public void clearSearchPaths()

  Clear the search paths.

### getMaxReturn

    public int getMaxReturn()

  Get the maximum number of objects to return.

  Use less than 0 to signify returning all matches.

### setMaxReturn

    public void setMaxReturn(int maxReturn)

  Set the maximum number of objects to return.

  Use less than 0 to signify returning all matches.

### getSortCriteria

    public SortCriteria[] getSortCriteria()

  Get the sort criteria.

### setSortCriteria

    public void setSortCriteria(SortCriteria[] sortCriteria)

  Set the sort criteria.

### setSortCriteria

    public void setSortCriteria(String sort)
                         throws IllegalArgumentException

  Set the sort criteria.

  Throws
    `IllegalArgumentException` - if the str string isn't valid occurred to `SortCriteria.getSortCriteria(java.lang.String)`.

### getExpression

    public Expression getExpression()

  Get the search expression.

### getFullTextExpression

    public IFullTextSearch getFullTextExpression()

  Get the search expression corresponding to a full text search.

### setFullTextExpression

    public void setFullTextExpression(IFullTextSearch expression)

  Set the search expression corresponding to a full text search.

### setExpression

    public void setExpression(Expression expression)

  Set the search expression.

### getContextParams

    public Map getContextParams()

  Get an unmodifiable copy of the context params.

### setContextParams

    public void setContextParams(Map input)

  Set the context params based upon the objects in the input map.

### getContextParam

    public Object getContextParam(Object key)

  Get the value of a context param.

### setContextParam

    public Object setContextParam(Object key,
                                  Object value)

  Set the value of a context param.

  The key and value must be Serializable.

  Parameters
    `key` - the context param key.
    `value` - the context param value.
  Returns
    the old context param value or null if none.

### clone

    public Object clone()

  Make a deep copy of this object

  Overrides:
    `clone` in class `Object`

### hashCode

    public int hashCode()

  Override hashcode to use our parts.

  Overrides:
    `hashCode` in class `Object`

### isUseCache

    public boolean isUseCache()

  Indicates whether or not the search, when executed will try to use the global search cache or not. The default value is true, so every search will try to find data in the search cache first.

  Returns
    true if the search will use the global search cache

### setUseCache

    public void setUseCache(boolean useCache)

  Indicates to the search API whether or not to use the search cache when executing the search expression. The default value is true, so every search will try to find data in the search cache first. If set to false the search cache will be ignored when querying.

  Parameters
    `useCache` - variable indicating whether or not to use the search cache.

### equals

    public boolean equals(Object o)

  Determine if another object is equals to this.

  Overrides:
    `equals` in class `Object`

### toString

    public String toString()

  Get a String representation of this.

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006 BEA Systems, Inc. All Rights Reserved